searchData={"items":[{"type":"module","title":"AliyunOpenAPI","doc":"An SDK builder for Aliyun / Alibaba Cloud OpenAPI.","ref":"AliyunOpenAPI.html"},{"type":"module","title":"Basic concepts - AliyunOpenAPI","doc":"An API call will go through the following steps:\n\n1. creating a config.\n2. creating a spec.\n3. transforming the spec to a HTTP request.\n4. sending the HTTP request.","ref":"AliyunOpenAPI.html#module-basic-concepts"},{"type":"module","title":"Quick start - AliyunOpenAPI","doc":"Add necessary packages:\n\n    {:aliyun_open_api, \"~> 0.6\"},\n    {:finch, \"~> 0.18\"},\n\nStart a Finch child in your supervision tree:\n\n    children = [\n      {Finch, name: AliyunOpenAPI.Finch}\n    ]\n\nMake a request:\n\n    alias AliyunOpenAPI.Config\n    alias AliyunOpenAPI.Specs.RPC\n    alias AliyunOpenAPI.HTTP.Request\n    alias AliyunOpenAPI.HTTP.Client\n\n    # 1. create a config\n    config =\n      Config.new!(\n        access_key_id: \"...\",\n        access_key_secret: \"...\"\n      )\n\n    # 2. create a spec\n    RPC.new!(config,\n      method: :post,\n      endpoint: \"https://ecs-cn-hangzhou.aliyuncs.com/\",\n      shared_params: %{\n        \"Action\" => \"DescribeInstanceStatus\",\n        \"Version\" => \"2014-05-26\"\n      },\n      params: %{\n        \"RegionId\" => \"cn-hangzhou\"\n      }\n    )\n    # 3. transform the spec to a HTTP request\n    |> Request.from_spec!()\n    # 4. send the HTTP request\n    |> Client.request()\n\n> In order to accommodate as many different usage scenarios as possible,\n> `AliyunOpenAPI` provides only low-level APIs.\n>\n> If you find the API calls are tedious, consider to encapsulate the low-level\n> APIs by yourself. There are some examples in the `/examples` directory for\n> reference.","ref":"AliyunOpenAPI.html#module-quick-start"},{"type":"module","title":"API styles - AliyunOpenAPI","doc":"For a variety of reasons, Aliyun OpenAPI involves several different API styles:\n\n* RPC\n* ROA\n* OSS\n\nThese different styles of APIs are supported by different spec modules:\n\n* `AliyunOpenAPI.Specs.RPC`\n* `AliyunOpenAPI.Specs.ROA`\n* `AliyunOpenAPI.Specs.OSS`\n\n> Q: Which spec should I use?\n>\n> A: First, you should check the style of the API you wanna use.\n> See next section for more.","ref":"AliyunOpenAPI.html#module-api-styles"},{"type":"module","title":"Check the styles of APIs - AliyunOpenAPI","doc":"1. View the API style of a cloud service in the **List of operations by function**\n   topic of the API Reference for the service.\n2. Search for the API of a cloud service in [OpenAPI Explorer](https://next.api.alibabacloud.com/). In the API\n   Debugging module, check the SDK sample code:\n   * If the sample code involves writing parameters to headers, the API is in the ROA style.\n   * Otherwise, the API is in the RPC style.","ref":"AliyunOpenAPI.html#module-check-the-styles-of-apis"},{"type":"module","title":"About endpoints - AliyunOpenAPI","doc":"In official docs, the term *endpoint* refers to different things:\n\n* sometimes, it refers to a host, such as `ecs-cn-hangzhou.aliyuncs.com`.\n* sometimes, it refers to a URL, such as `https://ecs-cn-hangzhou.aliyuncs.com`.\n\nThis kind of inconsistency is annoying.\n\n`AliyunOpenAPI` will **always** use the term *endpoint* to refer to a base URL:\n\n     :// /","ref":"AliyunOpenAPI.html#module-about-endpoints"},{"type":"module","title":"Public endpoints - AliyunOpenAPI","doc":"* centralized deployments: ` :// .aliyuncs.com/`\n* multi-region deployments: ` :// . .aliyuncs.com/`","ref":"AliyunOpenAPI.html#module-public-endpoints"},{"type":"module","title":"private endpoints (aka VPC endpoints) - AliyunOpenAPI","doc":"Private endpoints are also known as VPC endpoints.\n\n* centralized deployments: ` :// .vpc-proxy.aliyuncs.com/`\n* multi-region deployments: ` :// -vpc. .aliyuncs.com/`","ref":"AliyunOpenAPI.html#module-private-endpoints-aka-vpc-endpoints"},{"type":"module","title":"Public endpoints vs. Private endpoints - AliyunOpenAPI","doc":"Public endpoints consume public network traffic.\n\nPrivate endpoints don't consume public network traffic. In addition, they provide higher network\nspeed, and higher level secure protection.\n\nPersonally, I recommend using private endpoints as much as possible.","ref":"AliyunOpenAPI.html#module-public-endpoints-vs-private-endpoints"},{"type":"module","title":"Authentication - AliyunOpenAPI","doc":"","ref":"AliyunOpenAPI.html#module-authentication"},{"type":"module","title":"Required credentials - AliyunOpenAPI","doc":"Required credentials can be a combination of the following data:\n\n* Access Key ID\n* Access Key Secret\n* STS Token\n\n> STS is the shorthand for Security Token Service. It allows developers to manage temporary\n> credentials to resources.\n\nPlease make sure that you have got the right ones.","ref":"AliyunOpenAPI.html#module-required-credentials"},{"type":"module","title":"Signature mechanisms - AliyunOpenAPI","doc":"Different API styles use different signature mechanisms.\n\nThe `AliyunOpenAPI.Specs.*` modules will try their best to include relevant\nimplementations. You don't have to implement these yourself.","ref":"AliyunOpenAPI.html#module-signature-mechanisms"},{"type":"module","title":"Authorization - AliyunOpenAPI","doc":"Before calling any API, please make sure that the required permission is granted.","ref":"AliyunOpenAPI.html#module-authorization"},{"type":"module","title":"AliyunOpenAPI.Config","doc":"A struct representing a config.","ref":"AliyunOpenAPI.Config.html"},{"type":"function","title":"AliyunOpenAPI.Config.new!/1","doc":"","ref":"AliyunOpenAPI.Config.html#new!/1"},{"type":"type","title":"AliyunOpenAPI.Config.opt/0","doc":"","ref":"AliyunOpenAPI.Config.html#t:opt/0"},{"type":"type","title":"AliyunOpenAPI.Config.opts/0","doc":"","ref":"AliyunOpenAPI.Config.html#t:opts/0"},{"type":"type","title":"AliyunOpenAPI.Config.t/0","doc":"","ref":"AliyunOpenAPI.Config.html#t:t/0"},{"type":"behaviour","title":"AliyunOpenAPI.HTTP.Client","doc":"The specification for a HTTP client.\n\nIt can be set to a client provided by `AliyunOpenAPI`, such as:\n\n    config :aliyun_open_api,\n      http_client: AliyunOpenAPI.HTTP.Client.Finch\n\nOr, set it to your own API client, such as:\n\n    config :aliyun_open_api,\n      http_client: MyHTTP.Client","ref":"AliyunOpenAPI.HTTP.Client.html"},{"type":"callback","title":"AliyunOpenAPI.HTTP.Client.init/0","doc":"Callback to initialize the given API client.","ref":"AliyunOpenAPI.HTTP.Client.html#c:init/0"},{"type":"function","title":"AliyunOpenAPI.HTTP.Client.request/1","doc":"Issues an HTTP request by the given HTTP client.\n\nWhen the `content-type` header of the response is `\"application/xml\"` or\n`\"text/xml\"`, this function will try to convert the XML body to a map\nwith snaked-cased keys.\n\nWhen the `content-type` header of the response is `\"application/json\"`,\nthis function will try to convert the body to a map with snaked-cased\nkeys.","ref":"AliyunOpenAPI.HTTP.Client.html#request/1"},{"type":"callback","title":"AliyunOpenAPI.HTTP.Client.request/1","doc":"Callback to send a request.","ref":"AliyunOpenAPI.HTTP.Client.html#c:request/1"},{"type":"type","title":"AliyunOpenAPI.HTTP.Client.body/0","doc":"","ref":"AliyunOpenAPI.HTTP.Client.html#t:body/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Client.headers/0","doc":"","ref":"AliyunOpenAPI.HTTP.Client.html#t:headers/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Client.response/0","doc":"The response of a request.","ref":"AliyunOpenAPI.HTTP.Client.html#t:response/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Client.status/0","doc":"","ref":"AliyunOpenAPI.HTTP.Client.html#t:status/0"},{"type":"module","title":"AliyunOpenAPI.HTTP.Client.Finch","doc":"Finch-based HTTP client.\n\nIn order to use `Finch` as the HTTP client, you must start `Finch` and\nprovide a `:name`. Often in your supervision tree:\n\n    children = [\n      {Finch, name: AliyunOpenAPI.Finch}\n    ]\n\nOr, in rare cases, dynamically:\n\n    Finch.start_link(name: AliyunOpenAPI.Finch)\n\nIf a name different from `AliyunOpenAPI.Finch` is used, or you want to\nuse an existing `Finch` instance, you can provide the name via the config:\n\n    config :aliyun_open_api,\n      finch_name: MyApp.Finch","ref":"AliyunOpenAPI.HTTP.Client.Finch.html"},{"type":"module","title":"AliyunOpenAPI.HTTP.Request","doc":"A struct representing an HTTP request.","ref":"AliyunOpenAPI.HTTP.Request.html"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.from_spec!/1","doc":"Creates an HTTP request struct from spec.","ref":"AliyunOpenAPI.HTTP.Request.html#from_spec!/1"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.new!/1","doc":"Creates an HTTP request struct.","ref":"AliyunOpenAPI.HTTP.Request.html#new!/1"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.put_body/2","doc":"","ref":"AliyunOpenAPI.HTTP.Request.html#put_body/2"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.put_header/3","doc":"","ref":"AliyunOpenAPI.HTTP.Request.html#put_header/3"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.put_new_header/3","doc":"","ref":"AliyunOpenAPI.HTTP.Request.html#put_new_header/3"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.put_new_query/3","doc":"","ref":"AliyunOpenAPI.HTTP.Request.html#put_new_query/3"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.put_query/3","doc":"","ref":"AliyunOpenAPI.HTTP.Request.html#put_query/3"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.url/1","doc":"Gets the url string of an HTTP request struct.","ref":"AliyunOpenAPI.HTTP.Request.html#url/1"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.body/0","doc":"Optional request body.","ref":"AliyunOpenAPI.HTTP.Request.html#t:body/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.headers/0","doc":"Request headers.","ref":"AliyunOpenAPI.HTTP.Request.html#t:headers/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.host/0","doc":"Request host.","ref":"AliyunOpenAPI.HTTP.Request.html#t:host/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.method/0","doc":"Request method.","ref":"AliyunOpenAPI.HTTP.Request.html#t:method/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.path/0","doc":"Request path.","ref":"AliyunOpenAPI.HTTP.Request.html#t:path/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.query/0","doc":"Optional request query.","ref":"AliyunOpenAPI.HTTP.Request.html#t:query/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.scheme/0","doc":"Request scheme.","ref":"AliyunOpenAPI.HTTP.Request.html#t:scheme/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.t/0","doc":"","ref":"AliyunOpenAPI.HTTP.Request.html#t:t/0"},{"type":"protocol","title":"AliyunOpenAPI.HTTP.Request.Transform","doc":"The protocol for transforming a spec to an `%HTTP.Request{}`.","ref":"AliyunOpenAPI.HTTP.Request.Transform.html"},{"type":"function","title":"AliyunOpenAPI.HTTP.Request.Transform.to_request!/1","doc":"Converts a spec struct to an HTTP request struct.","ref":"AliyunOpenAPI.HTTP.Request.Transform.html#to_request!/1"},{"type":"type","title":"AliyunOpenAPI.HTTP.Request.Transform.t/0","doc":"All the types that implement this protocol.","ref":"AliyunOpenAPI.HTTP.Request.Transform.html#t:t/0"},{"type":"module","title":"AliyunOpenAPI.HTTP.Response","doc":"A struct representing an HTTP response.","ref":"AliyunOpenAPI.HTTP.Response.html"},{"type":"type","title":"AliyunOpenAPI.HTTP.Response.body/0","doc":"","ref":"AliyunOpenAPI.HTTP.Response.html#t:body/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Response.headers/0","doc":"","ref":"AliyunOpenAPI.HTTP.Response.html#t:headers/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Response.status/0","doc":"","ref":"AliyunOpenAPI.HTTP.Response.html#t:status/0"},{"type":"type","title":"AliyunOpenAPI.HTTP.Response.t/0","doc":"","ref":"AliyunOpenAPI.HTTP.Response.html#t:t/0"},{"type":"protocol","title":"AliyunOpenAPI.Sign","doc":"The protocol for signing a target.","ref":"AliyunOpenAPI.Sign.html"},{"type":"function","title":"AliyunOpenAPI.Sign.sign/2","doc":"Signs a target.","ref":"AliyunOpenAPI.Sign.html#sign/2"},{"type":"type","title":"AliyunOpenAPI.Sign.t/0","doc":"All the types that implement this protocol.","ref":"AliyunOpenAPI.Sign.html#t:t/0"},{"type":"module","title":"AliyunOpenAPI.Sign.ACS3","doc":"A implementation for ACS V3 signature.\n\nRead more at:\n\n  * [Alibaba Cloud SDK > Product Overview > Request syntax and signature method V3](https://www.alibabacloud.com/help/en/sdk/product-overview/v3-request-structure-and-signature)\n  * [Alibaba Cloud SDK > Product Overview > Request syntax and signature method V3 (zh-Hans)](https://www.alibabacloud.com/help/zh/sdk/product-overview/v3-request-structure-and-signature)","ref":"AliyunOpenAPI.Sign.ACS3.html"},{"type":"module","title":"AliyunOpenAPI.Sign.OSS4","doc":"A implementation for OSS V4 signature.\n\nRead more at:\n\n  * [Object Storage Service > Developer Reference > Use the RESTful API to initiate requests](https://www.alibabacloud.com/help/en/oss/developer-reference/use-the-restful-api-to-initiate-requests/)\n  * [Object Storage Service > Developer Reference > Use the RESTful API to initiate requests (zh-Hans)](https://www.alibabacloud.com/help/zh/oss/developer-reference/use-the-restful-api-to-initiate-requests/)","ref":"AliyunOpenAPI.Sign.OSS4.html"},{"type":"module","title":"AliyunOpenAPI.Specs.OSS","doc":"Describes an OSS style API.\n\nRead more at:\n\n  * [Object Storage Service > Developer Reference > Use the RESTful API to initiate requests](https://www.alibabacloud.com/help/en/oss/developer-reference/use-the-restful-api-to-initiate-requests/)\n  * [Object Storage Service > Developer Reference > Use the RESTful API to initiate requests (zh-Hans)](https://help.aliyun.com/zh/oss/developer-reference/use-the-restful-api-to-initiate-requests/)","ref":"AliyunOpenAPI.Specs.OSS.html"},{"type":"module","title":"About `spec_opts` - AliyunOpenAPI.Specs.OSS","doc":"`spec_opts` is a plain map for describing a RESTful API request.","ref":"AliyunOpenAPI.Specs.OSS.html#module-about-spec_opts"},{"type":"module","title":"Adding signature - AliyunOpenAPI.Specs.OSS","doc":"This implementation has built-in V4 signature support, and it's controlled\nby the `:sign_type` option:\n\n  * `:header` - add signature to the headers of request.\n  * `:url` - add signature to the url of request.\n\n> V1 signature is not supported.","ref":"AliyunOpenAPI.Specs.OSS.html#module-adding-signature"},{"type":"module","title":"Required headers - AliyunOpenAPI.Specs.OSS","doc":"All necessary headers of requests will be generated automatically. You don't\nhave to specifically set them, unless you want to customize it.","ref":"AliyunOpenAPI.Specs.OSS.html#module-required-headers"},{"type":"module","title":"Examples - AliyunOpenAPI.Specs.OSS","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#module-examples"},{"type":"module","title":"Send a request for `ListBucktets` operation - AliyunOpenAPI.Specs.OSS","doc":"alias AliyunOpenAPI.Config\n    alias AliyunOpenAPI.Specs.OSS\n    alias AliyunOpenAPI.HTTP.Request\n    alias AliyunOpenAPI.HTTP.Client\n\n    config =\n      Config.new!(\n        access_key_id: \"...\",\n        access_key_secret: \"...\"\n      )\n\n    OSS.new!(config,\n      sign_type: :header,\n      region: \"oss-us-west-1\",\n      endpoint: \"https://oss-us-west-1.aliyuncs.com/\",\n      method: :get,\n      path: \"/\"\n    )\n    |> Request.from_spec!()\n    |> Client.request()","ref":"AliyunOpenAPI.Specs.OSS.html#module-send-a-request-for-listbucktets-operation"},{"type":"module","title":"Create a pre-signed url for `GetObject` operation - AliyunOpenAPI.Specs.OSS","doc":"alias AliyunOpenAPI.Config\n    alias AliyunOpenAPI.Specs.OSS\n    alias AliyunOpenAPI.HTTP.Request\n\n    config =\n      Config.new!(\n        access_key_id: \"...\",\n        access_key_secret: \"...\"\n      )\n\n    OSS.new!(config,\n      sign_type: :url,\n      region: \"oss-us-west-1\",\n      bucket: \"example-bucket\",\n      endpoint: \"https://example-bucket.oss-us-west-1.aliyuncs.com/\",\n      method: :get,\n      path: \"/example-object\",\n      headers: %{\n        \"x-oss-expires\" => 900\n      }\n    )\n    |> Request.from_spec!()\n    |> Request.url()","ref":"AliyunOpenAPI.Specs.OSS.html#module-create-a-pre-signed-url-for-getobject-operation"},{"type":"function","title":"AliyunOpenAPI.Specs.OSS.new!/2","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#new!/2"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.body/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:body/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.bucket/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:bucket/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.endpoint/0","doc":"The base url that the request is sent to.\n\nFollowing formats are supported:\n\n  * region URL, such as `https://oss-us-west-1.aliyuncs.com`.\n  * virtual-hosted style URL, such as `https://example-bucket.oss-us-west-1.aliyuncs.com`.\n  * custom domain name, such as `https://www.example.com`.\n  * ...","ref":"AliyunOpenAPI.Specs.OSS.html#t:endpoint/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.headers/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:headers/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.method/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:method/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.path/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:path/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.query/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:query/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.region/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:region/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.sign_type/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:sign_type/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.spec_opt/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:spec_opt/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.spec_opts/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:spec_opts/0"},{"type":"type","title":"AliyunOpenAPI.Specs.OSS.t/0","doc":"","ref":"AliyunOpenAPI.Specs.OSS.html#t:t/0"},{"type":"module","title":"AliyunOpenAPI.Specs.OSS.Object","doc":"Provides object related utils.","ref":"AliyunOpenAPI.Specs.OSS.Object.html"},{"type":"function","title":"AliyunOpenAPI.Specs.OSS.Object.presign_post_object/5","doc":"Presigns a `PostObject` operation and returns the necessary form data when\nexecuting the `PostObject` operation.\n\nRead more at:\n\n  * [PostObject](https://www.alibabacloud.com/help/en/oss/developer-reference/postobject)\n  * [PostObject (zh-Hans)](https://help.aliyun.com/zh/oss/developer-reference/postobject)","ref":"AliyunOpenAPI.Specs.OSS.Object.html#presign_post_object/5"},{"type":"function","title":"Adding signature - AliyunOpenAPI.Specs.OSS.Object.presign_post_object/5","doc":"This implementation has built-in V4 signature support.\n\n> V1 signature is not supported.","ref":"AliyunOpenAPI.Specs.OSS.Object.html#presign_post_object/5-adding-signature"},{"type":"function","title":"Examples - AliyunOpenAPI.Specs.OSS.Object.presign_post_object/5","doc":"config =\n      Config.new!(\n        access_key_id: \"...\",\n        access_key_secret: \"...\"\n      )\n\n    region = \"oss-us-west-1\"\n    bucket = \"example-bucket\"\n    conditions = [\n      [\"eq\", \"$key\", \"lenna.png\"],\n      [\"eq\", \"$x-oss-object-acl\", \"private\"],\n      [\"content-length-range\", 1, 1024 * 1024 * 5]\n    ]\n    seconds_to_expire = 3600\n\n    presign_post_object(config, region, bucket, conditions, seconds_to_expire)\n\n    # returns:\n    #\n    # %{\n    #   policy: \"eyJjb25ka ... jM1OjUxWiJ9\",\n    #   \"x-oss-signature-version\": \"OSS4-HMAC-SHA256\",\n    #   \"x-oss-credential\": \".../20240519/us-west-1/oss/aliyun_v4_request\",\n    #   \"x-oss-date\": \"20240519T143551Z\",\n    #   \"x-oss-signature\": \"4526fe7c1e9f58f3da7edbfb31758721564f38bfba5cdd3f5d8d5ae67a60c60b\"\n    # }","ref":"AliyunOpenAPI.Specs.OSS.Object.html#presign_post_object/5-examples"},{"type":"module","title":"AliyunOpenAPI.Specs.ROA","doc":"Describes an ROA style API.\n\n> ROA is a resource-oriented architectural style and an extension of\n> the REST style.\n\nAPIs in the RPC style include:\n\n  * Application Real-Time Monitoring Service (ARMS)\n  * Batch Compute, Container Service for Kubernetes (ACK)\n  * Elasticsearch\n  * ...","ref":"AliyunOpenAPI.Specs.ROA.html"},{"type":"function","title":"AliyunOpenAPI.Specs.ROA.new!/2","doc":"","ref":"AliyunOpenAPI.Specs.ROA.html#new!/2"},{"type":"type","title":"AliyunOpenAPI.Specs.ROA.t/0","doc":"","ref":"AliyunOpenAPI.Specs.ROA.html#t:t/0"},{"type":"module","title":"AliyunOpenAPI.Specs.RPC","doc":"Describes an RPC style API.\n\nAPIs in the RPC style include:\n\n  * Elastic Compute Service (ECS)\n  * Content Delivery Network (CDN)\n  * ApsaraDB RDS\n  * ...","ref":"AliyunOpenAPI.Specs.RPC.html"},{"type":"module","title":"Examples - AliyunOpenAPI.Specs.RPC","doc":"alias AliyunOpenAPI.Config\n    alias AliyunOpenAPI.Specs.RPC\n\n    config =\n      Config.new!(\n        access_key_id: \"...\",\n        access_key_secret: \"...\"\n      )\n\n    RPC.new!(config,\n      endpoint: \"https://ecs-cn-hangzhou.aliyuncs.com/\",\n      method: :post,\n      version: \"2015-11-23\",\n      action: \"DescribeInstanceStatus\",\n      params: %{\n        \"RegionId\" => \"cn-hangzhou\"\n      }\n    )","ref":"AliyunOpenAPI.Specs.RPC.html#module-examples"},{"type":"function","title":"AliyunOpenAPI.Specs.RPC.new!/2","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#new!/2"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.action/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:action/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.endpoint/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:endpoint/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.headers/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:headers/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.method/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:method/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.params/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:params/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.spec_opt/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:spec_opt/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.spec_opts/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:spec_opts/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.t/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:t/0"},{"type":"type","title":"AliyunOpenAPI.Specs.RPC.version/0","doc":"","ref":"AliyunOpenAPI.Specs.RPC.html#t:version/0"},{"type":"extras","title":"AliyunOpenAPI","doc":"# AliyunOpenAPI\n\n[![Hex.pm](https://img.shields.io/hexpm/v/aliyun_open_api.svg)](https://hex.pm/packages/aliyun_open_api)\n\n> An SDK builder for Aliyun / Alibaba Cloud OpenAPI.\n\nThis package is an SDK builder. It provides utilities to reduce the cost of creating an SDK, such as:\n\n- building requests\n- signing requests\n- sending requests\n- ...\n\nAnd, this package was designed according to certain principles:\n\n- It provides only low-level APIs.\n- It doesn't touch the response body.\n- It doesn't provide one-to-one mapping against all available APIs. See the reason in [FAQ](#faq).","ref":"readme.html"},{"type":"extras","title":"Notes - AliyunOpenAPI","doc":"This package is still in its early stages, so it may still undergo significant changes, potentially leading to breaking changes.","ref":"readme.html#notes"},{"type":"extras","title":"Installation - AliyunOpenAPI","doc":"Add `:aliyun_open_api` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:aliyun_open_api, \"~>  \"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AliyunOpenAPI","doc":"For more information, see the [documentation](https://hexdocs.pm/aliyun_open_api/AliyunOpenAPI.html).","ref":"readme.html#usage"},{"type":"extras","title":"FAQ - AliyunOpenAPI","doc":"","ref":"readme.html#faq"},{"type":"extras","title":"Why not providing one-to-one mapping against all available APIs? - AliyunOpenAPI","doc":"Because:\n\n- It's hard to do the mapping automatically:\n  - The official API documentation isn't structured data.\n  - It's hard to parse and map them to API requests.\n- It's hard to do all the mapping manually:\n  - It's a tedius work.\n  - It's error-prone.\n- For an individual like me, this is a significant amount of work. I don't want to spend my time on such things.\n\nAnd, in most real apps, it's rare that all available APIs are required. In general, only a few API are required. So, mapping what is required is acceptable.\n\nThe simpler, the better.","ref":"readme.html#why-not-providing-one-to-one-mapping-against-all-available-apis"},{"type":"extras","title":"Why not using a simple and short name? - AliyunOpenAPI","doc":"I want to describe what a package does clearly and explicitly. The length of a name doesn't matter, as long as it is clear and explicit.","ref":"readme.html#why-not-using-a-simple-and-short-name"},{"type":"extras","title":"License - AliyunOpenAPI","doc":"[Apache License 2.0](http://www.apache.org/licenses/LICENSE-2.0)","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}